/* -------------------------------------------------------------------------------------------------------------------
MIDISightReader MuseScore plugin V2.0.
Copyright Don Horrell 2012, 2015. All rights reserved. http://www.donaldhorrell.co.uk
You may use this plugin for any commercial or non-commercial use.

This software uses the JavaOSC library which is Copyright (c) 2002-2006, C. Ramakrishnan / Illposed Software All rights reserved.

Requirements:
    You must have Java 6 (Java 1.6) installed.
    You need MuseScore version 2.0.1 or higher.
    Make sure Java is on your path.

Configuration:
    Edit MIDISightReader.properties and add your MIDI keyboard.
    Choose from the following installed MIDI devices:
        Real Time Sequencer

In MuseScore, turn OSC on (Edit|Preferences menu, General tab).
Turn the MIDISightReader plugin on (Edit|Preferences menu, Plugins tab) and quit MuseScore.
Unplug your MIDI keyboard from your computer, start MuseScore, then plug the MIDI keyboard in.
When the plugin is ready, the first notes will turn red.

Best practice:
    Make your score read-only before using this plugin, and do not save it after using this plugin.
------------------------------------------------------------------------------------------------------------------- */

import QtQuick 2.0
import MuseScore 1.0
import FileIO 1.0



MuseScore 
{
      menuPath: "Plugins.MidiSightReader"
      version:  "2.0"
      description: "MIDI sight reader."

      QProcess {
         id: proc
      }

      onRun: 
      {
            if (typeof curScore === 'undefined' || curScore == null)
            {
                  Qt.quit();
                  return;
            }

            console.log("-----------------");
            console.log(menuPath);
            console.log(filePath);
            console.log(midiFile.source);

            // Write the score to a MIDI file.
            writeScore(curScore, midiFile.source, "mid");

            // Start the Midi sight reader.
            var commandLine = filePath+"/MIDISightReader/MIDISightReader.bat";
            //var commandLine = filePath+"/MIDISightReader/MIDISightReader.bash";
            console.log(commandLine);
            proc.start(commandLine);
            console.log("Complete.");
            Qt.quit()
            
      }


      FileIO {
            id: midiFile
            source: tempPath() + "/MIDI_Sight_Reader.mid"
            onError: console.log(msg)
      }
}

